=== modified file 'breezy/git/dir.py'
--- breezy/git/dir.py	2020-03-22 19:12:43 +0000
+++ breezy/git/dir.py	2020-03-22 20:02:36 +0000
@@ -259,7 +259,12 @@
             result_dir.open_branch().set_last_revision(revision_id)
         if not no_tree and isinstance(result_dir.root_transport, LocalTransport):
             if result_dir.open_repository().make_working_trees():
-                result_dir.create_workingtree()
+                try:
+                    local_wt = self.open_workingtree()
+                except brz_errors.NotLocalUrl:
+                    result_dir.create_workingtree(revision_id=revision_id)
+                else:
+                    local_wt.clone(result_dir, revision_id=revision_id)
 
         return result_dir
 

=== modified file 'breezy/git/tests/test_blackbox.py'
--- breezy/git/tests/test_blackbox.py	2020-03-22 19:12:43 +0000
+++ breezy/git/tests/test_blackbox.py	2020-03-22 20:02:36 +0000
@@ -373,7 +373,7 @@
         self.run_bzr(["git-import", "--colocated", "a", "b"])
         self.assertEqual(set([".bzr"]), set(os.listdir("b")))
         b = ControlDir.open("b")
-        self.assertEqual(["abranch"], b.get_branches().branch_names())
+        self.assertEqual(["abranch"], b.branch_names())
         self.assertEqual(["atag"],
                          list(b.open_branch("abranch").tags.get_tag_dict().keys()))
 

=== modified file 'breezy/git/tests/test_remote.py'
--- breezy/git/tests/test_remote.py	2020-03-22 18:52:18 +0000
+++ breezy/git/tests/test_remote.py	2020-03-22 20:02:36 +0000
@@ -567,7 +567,8 @@
         self.assertEqual(
             {'': 'master', 'blah': 'blah', 'master': 'master'},
             {n: b.name for (n, b) in remote.get_branches().items()})
-        self.assertEqual(['', 'blah', 'master'], remote.branch_names())
+        self.assertEqual(
+            set(['', 'blah', 'master']), set(remote.branch_names()))
 
     def test_remove_tag(self):
         c1 = self.remote_real.do_commit(

